/*
========================================================================
 Name        : SocketsClientDocument.h
 Copyright   : Symbian Academy, 2007
 Description : Represents persistent data of the application.
               Creates instance of the AppUi.
 =======================================================================
 */
#ifndef SOCKETSCLIENTDOCUMENT_H
#define SOCKETSCLIENTDOCUMENT_H

#include <akndoc.h>
		
class CEikAppUi;

/**
* @class	CSocketsClientDocument SocketsClientDocument.h
* @brief	A CAknDocument-derived class is required by the S60 application 
*           framework. It is responsible for creating the AppUi object. 
*/
class CSocketsClientDocument : public CAknDocument
	{
public: 
	// constructor
	static CSocketsClientDocument* NewL( CEikApplication& aApp );

private: 
	// constructors
	CSocketsClientDocument( CEikApplication& aApp );
	void ConstructL();
	
public: 
	// from base class CEikDocument
	CEikAppUi* CreateAppUiL();
	};
#endif // SOCKETSCLIENTDOCUMENT_H
