/*
 ========================================================================
 Name        : SocketsClientContainerView.cpp
 Copyright   : Symbian Academy, 2007
 Description : Handles the user interface and interaction for the main view.
 ========================================================================
 */
// [[[ begin generated region: do not modify [Generated System Includes]
#include <aknviewappui.h>
#include <eikmenub.h>
#include <avkon.hrh>
#include <barsread.h>
#include <stringloader.h>
#include <eiklabel.h>
#include <eikenv.h>
#include <akncontext.h>
#include <akntitle.h>
#include <eikbtgpc.h>
#include <SocketsClient.rsg>
// ]]] end generated region [Generated System Includes]

// [[[ begin generated region: do not modify [Generated User Includes]
#include "SocketsClient.hrh"
#include "SocketsClientContainerView.h"
#include "SocketsClientContainer.hrh"
#include "SocketsClientContainer.h"
// ]]] end generated region [Generated User Includes]

// [[[ begin generated region: do not modify [Generated Constants]
// ]]] end generated region [Generated Constants]


/** 
 * The view's destructor removes the container from the control
 * stack and destroys it.
 */
CSocketsClientContainerView::~CSocketsClientContainerView()
	{
	// [[[ begin generated region: do not modify [Generated Contents]
	delete iSocketsClientContainer;
	iSocketsClientContainer = NULL;
	// ]]] end generated region [Generated Contents]

	}

/**
 * Symbian two-phase constructor.
 * This creates an instance then calls the second-phase constructor
 * without leaving the instance on the cleanup stack.
 * @return new instance of CSocketsClientContainerView
 */
CSocketsClientContainerView* CSocketsClientContainerView::NewL()
	{
	CSocketsClientContainerView* self = CSocketsClientContainerView::NewLC ();
	CleanupStack::Pop ( self);
	return self;
	}

/**
 * Symbian two-phase constructor.
 * This creates an instance, pushes it on the cleanup stack,
 * then calls the second-phase constructor.
 * @return new instance of CSocketsClientContainerView
 */
CSocketsClientContainerView* CSocketsClientContainerView::NewLC()
	{
	CSocketsClientContainerView* self = new ( ELeave ) CSocketsClientContainerView();
	CleanupStack::PushL ( self);
	self->ConstructL ();
	return self;
	}

/**
 * Second-phase constructor for view.  
 * Initialize contents from resource.
 */
void CSocketsClientContainerView::ConstructL()
	{
	// [[[ begin generated region: do not modify [Generated Code]
	BaseConstructL( R_SOCKETS_CLIENT_CONTAINER_SOCKETS_CLIENT_CONTAINER_VIEW );
	// ]]] end generated region [Generated Code]

	// add your own initialization code here
	}

/**
 * @return The UID for this view
 */
TUid CSocketsClientContainerView::Id() const
	{
	return TUid::Uid ( ESocketsClientContainerViewId);
	}

/**
 * Handle a command for this view (override)
 * @param aCommand command id to be handled
 */
void CSocketsClientContainerView::HandleCommandL( TInt aCommand)
	{
	// [[[ begin generated region: do not modify [Generated Code]
	TBool commandHandled = EFalse;
	switch ( aCommand )
		{	// code to dispatch to the AknView's menu and CBA commands is generated here
		case ESocketsClientContainerViewConnectMenuItemCommand:
			commandHandled = HandleConnectMenuItemSelectedL( aCommand );
			break;
		case ESocketsClientContainerViewLoginMenuItemCommand:
			commandHandled = HandleLoginMenuItemSelectedL( aCommand );
			break;
		default:
			break;
		}
	
		
	if ( !commandHandled ) 
		{
	
		if ( aCommand == EAknSoftkeyExit )
			{
			AppUi()->HandleCommandL( EEikCmdExit );
			}
	
		}
	// ]]] end generated region [Generated Code]

	}

/**
 *	Handles user actions during activation of the view, 
 *	such as initializing the content.
 */
void CSocketsClientContainerView::DoActivateL(
		const TVwsViewId& /*aPrevViewId*/, TUid /*aCustomMessageId*/,
		const TDesC8& /*aCustomMessage*/)
	{
	// [[[ begin generated region: do not modify [Generated Contents]
	SetupStatusPaneL();
	
	CEikButtonGroupContainer* cba = AppUi()->Cba();
	if ( cba != NULL ) 
		{
		cba->MakeVisible( EFalse );
		}
	
	if ( iSocketsClientContainer == NULL )
		{
		iSocketsClientContainer = CSocketsClientContainer::NewL( ClientRect(), NULL, this );
		iSocketsClientContainer->SetMopParent( this );
		AppUi()->AddToStackL( *this, iSocketsClientContainer );
		} 
	// ]]] end generated region [Generated Contents]


	}

/**
 */
void CSocketsClientContainerView::DoDeactivate()
	{
	// [[[ begin generated region: do not modify [Generated Contents]
	CleanupStatusPane();
	
	CEikButtonGroupContainer* cba = AppUi()->Cba();
	if ( cba != NULL ) 
		{
		cba->MakeVisible( ETrue );
		cba->DrawDeferred();
		}
	
	if ( iSocketsClientContainer != NULL )
		{
		AppUi()->RemoveFromViewStack( *this, iSocketsClientContainer );
		delete iSocketsClientContainer;
		iSocketsClientContainer = NULL;
		}
	// ]]] end generated region [Generated Contents]

	}

// [[[ begin generated function: do not modify
void CSocketsClientContainerView::SetupStatusPaneL()
	{
	// reset the context pane
	TUid contextPaneUid = TUid::Uid( EEikStatusPaneUidContext );
	CEikStatusPaneBase::TPaneCapabilities subPaneContext = 
		StatusPane()->PaneCapabilities( contextPaneUid );
	if ( subPaneContext.IsPresent() && subPaneContext.IsAppOwned() )
		{
		CAknContextPane* context = static_cast< CAknContextPane* > ( 
			StatusPane()->ControlL( contextPaneUid ) );
		context->SetPictureToDefaultL();
		}
	
	// setup the title pane
	TUid titlePaneUid = TUid::Uid( EEikStatusPaneUidTitle );
	CEikStatusPaneBase::TPaneCapabilities subPaneTitle = 
		StatusPane()->PaneCapabilities( titlePaneUid );
	if ( subPaneTitle.IsPresent() && subPaneTitle.IsAppOwned() )
		{
		CAknTitlePane* title = static_cast< CAknTitlePane* >( 
			StatusPane()->ControlL( titlePaneUid ) );
		TResourceReader reader;
		iEikonEnv->CreateResourceReaderLC( reader, R_SOCKETS_CLIENT_CONTAINER_TITLE_RESOURCE );
		title->SetFromResourceL( reader );
		CleanupStack::PopAndDestroy(); // reader internal state
		}
				
	}
// ]]] end generated function

// [[[ begin generated function: do not modify
void CSocketsClientContainerView::CleanupStatusPane()
	{
	}
// ]]] end generated function

void CSocketsClientContainerView::DynInitMenuPaneL (TInt aResourceId, CEikMenuPane *aMenuPane) 
	{
	if (aResourceId == R_SOCKETS_CLIENT_CONTAINER_MENU_PANE1_MENU_PANE)
		{
		// Only allow to connect if the sockets engine is currently disconnected
		aMenuPane->SetItemDimmed(ESocketsClientContainerViewConnectMenuItemCommand, iSocketsEngine->IsConnected());
		// Only allow to login if the sockets engine is connected and the game
		// engine reports that it isn't currently logged in.
		aMenuPane->SetItemDimmed(ESocketsClientContainerViewLoginMenuItemCommand, !(iSocketsEngine->IsConnected() && !iMasteroidsEngine->IsLoggedIn()));
		}
	}

/** 
 * Handle status pane size change for this view (override)
 */
void CSocketsClientContainerView::HandleStatusPaneSizeChange()
	{
	CAknView::HandleStatusPaneSizeChange ();

	// this may fail, but we're not able to propagate exceptions here
	TInt result;
	TRAP( result, SetupStatusPaneL() );
	}

/** 
 * Handle the selected event.
 * @param aCommand the command id invoked
 * @return ETrue if the command was handled, EFalse if not
 */
TBool CSocketsClientContainerView::HandleConnectMenuItemSelectedL( TInt aCommand)
	{
	// TODO: Define the IP address of the game server!
	_LIT(KUrl, "127.0.0.1");
	// Edit 37: Setup a TInetAddr object. Include the required header file
	//          (see the SDK-documentation).
	//          Feed the URL defined through the literal above to the
	//          TInetAddr-object (e.g. by using its Input() method).
	//          Make sure to handle the return code, e.g. by leaving
	//          in case of an error.
	//          Additionally, set the port of the object - the default
	//          port of the masteroids server is 45315.
	
	
	
	// Edit 38: Connect to the URL with the sockets engine
	
	
	// Edit 39: Add the NetworkServices-Capability to the mmp editor
	//          to be able to access the Internet in Symbian OS 9.
	//          Note: The emulator doesn't check capabilities by default,
	//          but can be configured to do so. Devices will check in any
	//          case.
	//          Warning: You should only try this game on a device if you're
	//          connected via WLAN or have a flat rate data plan.
	
	return ETrue;
	}

void CSocketsClientContainerView::SetEngines(
		CMasteroidsEngine* aMasteroidsEngine, CSocketsEngine* aSocketsEngine)
	{
	iMasteroidsEngine = aMasteroidsEngine;
	iSocketsEngine = aSocketsEngine;
	}

void CSocketsClientContainerView::SetStatusTextL(const TDesC& aText)
	{
	if (iSocketsClientContainer)
		iSocketsClientContainer->SetStatusTextL(aText);
	}

/**
 * First phase of Symbian two-phase construction. Should not contain any
 * code that could leave.
 */
CSocketsClientContainerView::CSocketsClientContainerView()
	{
	// [[[ begin generated region: do not modify [Generated Contents]
	iSocketsClientContainer = NULL;
	// ]]] end generated region [Generated Contents]

	}
/** 
 * Handle the selected event.
 * @param aCommand the command id invoked
 * @return ETrue if the command was handled, EFalse if not
 */
TBool CSocketsClientContainerView::HandleLoginMenuItemSelectedL( TInt aCommand)
	{
	// TODO: Define your username
	_LIT8(KUsername, "Symbian");
	iMasteroidsEngine->SendLoginL (KUsername);
	return ETrue;
	}

