/*
 ============================================================================
 Name		 : SocketsReader.cpp
 Copyright   : Symbian Academy, 2007
 Description : Waits for data from the connected socket and informs a 
               listener via a callback whenever data is received.
============================================================================
*/

#include "SocketsReader.h"

CSocketsReader::CSocketsReader(RSocket* aSocket, MSocketsNotifier* aNotifier) :
	CActive( EPriorityStandard), // Standard priority
			iSocket(aSocket), iNotifier(aNotifier)
	{
	}

CSocketsReader* CSocketsReader::NewLC(RSocket* aSocket,
		MSocketsNotifier* aNotifier)
	{
	CSocketsReader* self = new ( ELeave ) CSocketsReader(aSocket, aNotifier);
	CleanupStack::PushL ( self);
	self->ConstructL ();
	return self;
	}

CSocketsReader* CSocketsReader::NewL(RSocket* aSocket,
		MSocketsNotifier* aNotifier)
	{
	CSocketsReader* self = CSocketsReader::NewLC (aSocket, aNotifier);
	CleanupStack::Pop (); // self;
	return self;
	}

void CSocketsReader::ConstructL()
	{
	// Edit 30: Add this class to the active scheduler
	
	}

CSocketsReader::~CSocketsReader()
	{
	// Edit 31: Cancel any potentially outstanding read requests

	}

void CSocketsReader::DoCancel()
	{
	// Edit 34: Call the appropriate cancel method of the socket to 
	//          cancel the reading process - see the SDK help for details.

	}

void CSocketsReader::IssueReadL()
	{
	if ( !IsActive())
		{
		// Edit 32: Use the RecvOneOrMore() method of the socket to
		//          read data from the socket. Use the instance variables
		//          defined by this class / the CActive base class for
		//          the parameters. Set the flags-parameter to 0, as no
		//          special settings are required for this case.
		
		
		// Edit 33: Set this AO to active.

		}
	}

void CSocketsReader::RunL()
	{
	if ( iStatus != KErrNone)
		{
		_LIT(KSocketsReaderError, "Error: Sockets read");
		if ( iNotifier)
			iNotifier->NotifyInfo (iStatus.Int (), KSocketsReaderError);
		}
	else
		{
		// Edit 35: Send the received message to the listener (iNotifier).

		// Edit 36: Immediately issue the next read process by calling
		//          IssueReadL() again.
		
		}
	}

